<template>
  <v-row>
    <v-col class="pr-0 mr-0">
      <v-tabs
        v-model="selectedDashboard"
        bg-color="#2121219c"
        color="white"
        class="dashboard-tabs"
      >
        <v-tab v-for="d in dashboards" :key="d.id" :value="d">
          <span>{{ d.title }} </span>
          <v-btn
            v-if="editMode"
            color="#272727"
            variant="tonal"
            size="small"
            class="btn-create"
            @click="updateDialog(true, 'form-dashboard', d)"
          >
            <v-icon color="white">mdi-pencil</v-icon>
          </v-btn>
        </v-tab>
        <v-col class="tabs-action align-center">
          <v-btn
            color="#272727"
            variant="large"
            size="small"
            class="btn-create"
            @click="updateDialog(true, 'form-dashboard', null)"
          >
            <v-icon color="white">mdi-plus</v-icon>
          </v-btn>
        </v-col>
      </v-tabs>
    </v-col>
    <v-col align="right" class="edit-action" v-if="!editMode">
      <v-btn
        color="#272727"
        variant="tonal"
        size="small"
        class="btn-create"
        @click="editMode = true"
      >
        <v-icon color="white">mdi-pencil</v-icon>
      </v-btn>
    </v-col>
    <v-col align="right" class="edit-action mr-2" v-if="editMode">
      <v-btn
        color="white"
        variant="tonal"
        size="small"
        class="btn-create"
        @click="editMode = false"
      >
        Close
      </v-btn>
    </v-col>
  </v-row>

  <v-row>
    <v-col>
      <draggable
        :model-value="dataWidget"
        @update:model-value="updateOrdering"
        @start="drag = true"
        @end="drag = false"
        item-key="title"
        class="d-flex flex-wrap"
      >
        <template #item="{ element }">
          <v-col class="flex-grow-0" v-if="element.id != -1">
            <BarChart
              v-if="element.type == 'bar'"
              :options="{
                responsive: true,
                maintainAspectRatio: true,
              }"
              :data="element.data"
              :title="element.title"
              :id="element.id"
              :period="element?.period?.title"
              @delete:chart="onDeleteHandler"
              @duplicate:chart="onDuplicateHandler({ ...element })"
              @edit:chart="updateDialog(true, 'form-widget', { ...element })"
            />
            <LineChart
              v-if="element.type == 'line'"
              :options="{
                responsive: true,
                maintainAspectRatio: true,
              }"
              :data="element.data"
              :title="element.title"
              :id="element.id"
              :period="element?.period?.title"
              @delete:chart="onDeleteHandler"
              @duplicate:chart="onDuplicateHandler({ ...element })"
              @edit:chart="updateDialog(true, 'form-widget', { ...element })"
            />
            <PieChart
              v-if="element.type == 'pie'"
              :options="{ responsive: true, maintainAspectRatio: true }"
              :data="element.data"
              :title="element.title"
              :id="element.id"
              :period="element?.period?.title"
              @delete:chart="onDeleteHandler"
              @duplicate:chart="onDuplicateHandler({ ...element })"
              @edit:chart="updateDialog(true, 'form-widget', { ...element })"
            />
            <DoughnutChart
              v-if="element.type == 'doughnut'"
              :options="{ responsive: true, maintainAspectRatio: false }"
              :data="element.data"
              :title="element.title"
              :id="element.id"
              @delete:chart="onDeleteHandler"
            />
          </v-col>
          <v-col v-else>
            <NewChart @new:chart="updateDialog(true, 'widget', null)" />
          </v-col>
        </template>
      </draggable>
    </v-col>
  </v-row>
  <v-navigation-drawer
    class="bom-filters left-box-shadow"
    fixed
    permanent
    location="right"
    width="400"
    v-model="dialog.open"
    v-if="dialog.type == 'widget'"
  >
    <WidgetSlider
      @close:widget="updateDialog(false, null, null)"
      :dashboardId="selectedDashboard.id"
    />
  </v-navigation-drawer>
  <v-dialog
    v-model="dialog.open"
    scrollable
    v-if="dialog.type == 'form-widget'"
  >
    <FormChart
      @close:dialog="updateDialog(false, null, null)"
      :widget="dialog.data?.widget"
      @close:all="updateDialog(false, null, null)"
      :data="dialog.data"
      :dashboardId="selectedDashboard.id"
    />
  </v-dialog>
  <v-dialog
    v-model="dialog.open"
    scrollable
    v-if="dialog.type == 'form-dashboard'"
  >
    <FormDashboard
      @close:dialog="updateDialog(false, null, null)"
      :data="dialog.data"
    />
  </v-dialog>
</template>

<script>
import { mapState, mapActions } from "pinia";
import { useAppStore } from "@/store/app";
import { data, options } from "@/models/barData.js";
import BarChart from "@/components/BaseCharts/BarChart.vue";
import LineChart from "@/components/BaseCharts/LineChart.vue";
import PieChart from "@/components/BaseCharts/PieChart.vue";
import DoughnutChart from "@/components/BaseCharts/DoughnutChart.vue";
import WidgetSlider from "@/components/Sliders/WidgetSlider.vue";
import draggable from "vuedraggable";
import NewChart from "@/components/BaseCharts/NewChart.vue";
import FormChart from "@/components/Modals/FormChart.vue";
import FormDashboard from "@/components/Modals/FormDashboard.vue";
import { generateId } from "@/utils/utils";

export default {
  name: "Dashboard",
  components: {
    BarChart,
    LineChart,
    PieChart,
    draggable,
    DoughnutChart,
    WidgetSlider,
    NewChart,
    FormChart,
    FormDashboard,
  },
  data() {
    return {
      data: data,
      options: options,
      drag: false,
      dialog: {
        open: false,
        type: null,
        data: null,
      },
      defaultCard: [
        {
          id: -1,
        },
      ],
      selectedDashboard: null,
      editMode: false,
    };
  },

  computed: {
    ...mapState(useAppStore, ["dashboard", "dashboards"]),
    dataWidget() {
      let x = [...this.dashboard];
      let currentDashboard = x.filter((c) => {
        if (c.dashboardId == this.selectedDashboard.id) {
          return c;
        }
      });
      return [...currentDashboard, ...this.defaultCard];
    },
  },
  methods: {
    ...mapActions(useAppStore, ["onSetDashboard"]),
    updateDialog(open, type, data) {
      this.dialog = {
        open,
        type,
        data,
      };
    },
    updateOrdering(array) {
      let newArray = array.filter((a) => {
        if (a.id != -1) {
          return a;
        }
      });
      this.onSetDashboard(newArray);
    },
    onDeleteHandler(id) {
      let newData = this.dashboard.filter((d) => {
        if (d.id != id) return d;
      });
      this.onSetDashboard(newData);
    },
    onDuplicateHandler(element) {
      let newData = [...this.dashboard];
      let id = generateId(this.dashboard);
      element.id = id;
      element.title = element.title + " - copy";
      newData.push(element);
      this.onSetDashboard(newData);
    },
  },
};
</script>


<style scoped>
.tabs-action {
  background-color: #272727;
  max-height: 60px;
}
.dashboard-tabs {
  color: white;
}

.edit-action {
  display: flex;
  align-items: end;
  justify-content: end;
  background-color: #272727;
  max-height: 60px;
}
</style>